Index: /trunk/src/sys/arch/mips/mips/mips_emul.c
===================================================================
--- /trunk/src/sys/arch/mips/mips/mips_emul.c	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/mips_emul.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: mips_emul.c,v 1.14.78.10 2010/05/15 20:27:48 matt Exp $ */
+/*	$NetBSD: mips_emul.c,v 1.14.78.13 2011/04/29 08:26:28 matt Exp $ */
 
 /*
@@ -28,62 +28,23 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: mips_emul.c,v 1.14.78.10 2010/05/15 20:27:48 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: mips_emul.c,v 1.14.78.13 2011/04/29 08:26:28 matt Exp $");
 
 #include <sys/param.h>
 #include <sys/systm.h>
+#include <sys/cpu.h>
 #include <sys/proc.h>
-#include <sys/user.h>
 
 #include <mips/locore.h>
 #include <mips/mips_opcode.h>
 
-#include <machine/cpu.h>
 #include <mips/reg.h>
 #include <mips/regnum.h>			/* symbolic register indices */
+#include <machine/pcb.h>
 #include <machine/vmparam.h>			/* for VM_MAX_ADDRESS */
 #include <mips/trap.h>
-
-#if !defined(NOFPU) || defined(FPEMUL)
-void MachEmulateFP(uint32_t, struct reg *, uint32_t);
-#endif
 
 static inline void	send_sigsegv(intptr_t, uint32_t, struct trapframe *,
 			    uint32_t);
 static inline void	update_pc(struct trapframe *, uint32_t);
-
-vaddr_t MachEmulateBranch(struct trapframe *, vaddr_t, unsigned, int);
-void	MachEmulateInst(uint32_t, uint32_t, vaddr_t, struct trapframe *);
-
-void	MachEmulateLWC0(uint32_t, struct trapframe *, uint32_t);
-void	MachEmulateSWC0(uint32_t, struct trapframe *, uint32_t);
-void	MachEmulateSpecial(uint32_t, struct trapframe *, uint32_t);
-void	MachEmulateSpecial3(uint32_t, struct trapframe *, uint32_t);
-void	MachEmulateLWC1(uint32_t, struct trapframe *, uint32_t);
-void	MachEmulateLDC1(uint32_t, struct trapframe *, uint32_t);
-void	MachEmulateSWC1(uint32_t, struct trapframe *, uint32_t);
-void	MachEmulateSDC1(uint32_t, struct trapframe *, uint32_t);
-
-void	bcemul_lb(uint32_t, struct trapframe *, uint32_t);
-void	bcemul_lbu(uint32_t, struct trapframe *, uint32_t);
-void	bcemul_lh(uint32_t, struct trapframe *, uint32_t);
-void	bcemul_lhu(uint32_t, struct trapframe *, uint32_t);
-void	bcemul_lw(uint32_t, struct trapframe *, uint32_t);
-void	bcemul_lwl(uint32_t, struct trapframe *, uint32_t);
-void	bcemul_lwr(uint32_t, struct trapframe *, uint32_t);
-#if defined(__mips_n32) || defined(__mips_n64) || defined(__mips_o64)
-void	bcemul_ld(uint32_t, struct trapframe *, uint32_t);
-void	bcemul_ldl(uint32_t, struct trapframe *, uint32_t);
-void	bcemul_ldr(uint32_t, struct trapframe *, uint32_t);
-#endif
-void	bcemul_sb(uint32_t, struct trapframe *, uint32_t);
-void	bcemul_sh(uint32_t, struct trapframe *, uint32_t);
-void	bcemul_sw(uint32_t, struct trapframe *, uint32_t);
-void	bcemul_swl(uint32_t, struct trapframe *, uint32_t);
-void	bcemul_swr(uint32_t, struct trapframe *, uint32_t);
-#if defined(__mips_n32) || defined(__mips_n64) || defined(__mips_o64)
-void	bcemul_sd(uint32_t, struct trapframe *, uint32_t);
-void	bcemul_sdl(uint32_t, struct trapframe *, uint32_t);
-void	bcemul_sdr(uint32_t, struct trapframe *, uint32_t);
-#endif
 
 /*
@@ -100,6 +61,6 @@
  */
 vaddr_t
-MachEmulateBranch(struct trapframe *tf, vaddr_t instpc, unsigned fpuCSR,
-    int allowNonBranch)
+mips_emul_branch(struct trapframe *tf, vaddr_t instpc, uint32_t fpuCSR,
+    bool allowNonBranch)
 {
 #define	BRANCHTARGET(pc, i) (4 + (pc) + ((short)(i).IType.imm << 2))
@@ -110,5 +71,5 @@
 		inst.word = ufetch_uint32((void *)instpc);
 	else
-		inst.word = *(unsigned *)instpc;
+		inst.word = *(uint32_t *)instpc;
 
 	switch ((int)inst.JType.op) {
@@ -154,5 +115,5 @@
 	case OP_JAL:
 		nextpc = (inst.JType.target << 2) |
-			((unsigned)instpc & 0xF0000000);
+			((intptr_t)instpc & 0xF0000000);
 		break;
 
@@ -221,5 +182,5 @@
  */
 void
-MachEmulateInst(uint32_t status, uint32_t cause, vaddr_t opc,
+mips_emul_inst(uint32_t status, uint32_t cause, vaddr_t opc,
     struct trapframe *tf)
 {
@@ -238,38 +199,38 @@
 	switch (((InstFmt)inst).FRType.op) {
 	case OP_LWC0:
-		MachEmulateLWC0(inst, tf, cause);
+		mips_emul_lwc0(inst, tf, cause);
 		break;
 	case OP_SWC0:
-		MachEmulateSWC0(inst, tf, cause);
+		mips_emul_swc0(inst, tf, cause);
 		break;
 	case OP_SPECIAL:
-		MachEmulateSpecial(inst, tf, cause);
+		mips_emul_special(inst, tf, cause);
 		break;
 	case OP_SPECIAL3:
-		MachEmulateSpecial3(inst, tf, cause);
+		mips_emul_special3(inst, tf, cause);
 		break;
 	case OP_COP1:
 #if defined(FPEMUL)
-		MachEmulateFP(inst, &tf->tf_registers, cause);
+		mips_emul_fp(inst, tf, cause);
 		break;
 #endif
 	case OP_LWC1:
 #if defined(FPEMUL)
-		MachEmulateLWC1(inst, tf, cause);
+		mips_emul_lwc1(inst, tf, cause);
 		break;
 #endif
 	case OP_LDC1:
 #if defined(FPEMUL)
-		MachEmulateLDC1(inst, tf, cause);
+		mips_emul_ldc1(inst, tf, cause);
 		break;
 #endif
 	case OP_SWC1:
 #if defined(FPEMUL)
-		MachEmulateSWC1(inst, tf, cause);
+		mips_emul_swc1(inst, tf, cause);
 		break;
 #endif
 	case OP_SDC1:
 #if defined(FPEMUL)
-		MachEmulateSDC1(inst, tf, cause);
+		mips_emul_sdc1(inst, tf, cause);
 		break;
 #else
@@ -279,5 +240,5 @@
 	default:
 #if 1 /* def DEBUG */
-		printf("pid %d (%s): trap: bad insn %#"PRIxVADDR" cause %#x insn %#x\n", curproc->p_pid, curproc->p_comm, opc, cause, inst);
+		printf("pid %d (%s): trap: bad insn @ %#"PRIxVADDR" cause %#x insn %#x code %d\n", curproc->p_pid, curproc->p_comm, opc, cause, inst, code);
 #endif
 		tf->tf_regs[_R_CAUSE] = cause;
@@ -298,5 +259,5 @@
 {
 	ksiginfo_t ksi;
-	cause = (cause & 0xFFFFFF00) | (exccode << MIPS_CR_EXC_CODE_SHIFT);
+	cause = (cause & ~0xFF) | (exccode << MIPS_CR_EXC_CODE_SHIFT);
 	tf->tf_regs[_R_CAUSE] = cause;
 	tf->tf_regs[_R_BADVADDR] = vaddr;
@@ -315,5 +276,5 @@
 	if (cause & MIPS_CR_BR_DELAY)
 		tf->tf_regs[_R_PC] = 
-		    MachEmulateBranch(tf, tf->tf_regs[_R_PC],
+		    mips_emul_branch(tf, tf->tf_regs[_R_PC],
 			PCB_FSR(curpcb), 0);
 	else
@@ -325,5 +286,5 @@
  */
 void
-MachEmulateLWC0(uint32_t inst, struct trapframe *tf, uint32_t cause)
+mips_emul_lwc0(uint32_t inst, struct trapframe *tf, uint32_t cause)
 {
 	intptr_t	vaddr;
@@ -358,5 +319,5 @@
  */
 void
-MachEmulateSWC0(uint32_t inst, struct trapframe *tf, uint32_t cause)
+mips_emul_swc0(uint32_t inst, struct trapframe *tf, uint32_t cause)
 {
 	intptr_t	vaddr;
@@ -409,8 +370,10 @@
 
 void
-MachEmulateSpecial(uint32_t inst, struct trapframe *tf, uint32_t cause)
+mips_emul_special(uint32_t inst, struct trapframe *tf, uint32_t cause)
 {
 	ksiginfo_t ksi;
-	switch (((InstFmt)inst).RType.func) {
+	const InstFmt instfmt = { .word = inst };
+
+	switch (instfmt.RType.func) {
 	case OP_SYNC:
 		/* nothing */
@@ -432,13 +395,14 @@
 
 void
-MachEmulateSpecial3(uint32_t inst, struct trapframe *tf, uint32_t cause)
+mips_emul_special3(uint32_t inst, struct trapframe *tf, uint32_t cause)
 {
 	ksiginfo_t ksi;
-	switch (((InstFmt)inst).RType.func) {
+	const InstFmt instfmt = { .word = inst };
+	switch (instfmt.RType.func) {
 	case OP_RDHWR:
-		switch (((InstFmt)inst).RType.rd) {
+		switch (instfmt.RType.rd) {
 		case 29:
-			tf->tf_regs[((InstFmt)inst).RType.rt] =
-			    curlwp->l_md.md_tinfo;
+			tf->tf_regs[instfmt.RType.rt] =
+			    (mips_reg_t)(intptr_t)curlwp->l_private;
 			break;
 		}
@@ -453,5 +417,5 @@
 		ksi.ksi_addr = (void *)(intptr_t)tf->tf_regs[_R_PC];
 		(*curproc->p_emul->e_trapsignal)(curlwp, &ksi);
-		break;
+		return;
 	}
 
@@ -464,5 +428,5 @@
 
 void
-MachEmulateLWC1(uint32_t inst, struct trapframe *tf, uint32_t cause)
+mips_emul_lwc1(uint32_t inst, struct trapframe *tf, uint32_t cause)
 {
 	intptr_t	vaddr;
@@ -527,5 +491,5 @@
 
 void
-MachEmulateLDC1(uint32_t inst, struct trapframe *tf, uint32_t cause)
+mips_emul_ldc1(uint32_t inst, struct trapframe *tf, uint32_t cause)
 {
 	intptr_t	vaddr;
@@ -554,5 +518,5 @@
 
 void
-MachEmulateSWC1(uint32_t inst, struct trapframe *tf, uint32_t cause)
+mips_emul_swc1(uint32_t inst, struct trapframe *tf, uint32_t cause)
 {
 	intptr_t	vaddr;
@@ -617,5 +581,5 @@
 
 void
-MachEmulateSDC1(uint32_t inst, struct trapframe *tf, uint32_t cause)
+mips_emul_sdc1(uint32_t inst, struct trapframe *tf, uint32_t cause)
 {
 	intptr_t	vaddr;
@@ -644,5 +608,5 @@
 
 void
-bcemul_lb(uint32_t inst, struct trapframe *tf, uint32_t cause)
+mips_emul_lb(uint32_t inst, struct trapframe *tf, uint32_t cause)
 {
 	intptr_t	vaddr;
@@ -664,15 +628,15 @@
 	}
 
-	tf->tf_regs[(inst>>16)&0x1F] = (int32_t)x;
-
-	update_pc(tf, cause);
-}
-
-void
-bcemul_lbu(uint32_t inst, struct trapframe *tf, uint32_t cause)
-{
-	intptr_t	vaddr;
-	int16_t		offset;
-	uint8_t	x;
+	tf->tf_regs[(inst>>16)&0x1F] = x;
+
+	update_pc(tf, cause);
+}
+
+void
+mips_emul_lbu(uint32_t inst, struct trapframe *tf, uint32_t cause)
+{
+	intptr_t	vaddr;
+	int16_t		offset;
+	uint8_t		x;
 
 	offset = inst & 0xFFFF;
@@ -690,4 +654,56 @@
 	}
 
+	tf->tf_regs[(inst>>16)&0x1F] = x;
+
+	update_pc(tf, cause);
+}
+
+void
+mips_emul_lh(uint32_t inst, struct trapframe *tf, uint32_t cause)
+{
+	intptr_t	vaddr;
+	int16_t		offset;
+	int16_t		x;
+
+	offset = inst & 0xFFFF;
+	vaddr = tf->tf_regs[(inst>>21)&0x1F] + offset;
+
+	/* segment and alignment check */
+	if (vaddr > VM_MAXUSER_ADDRESS || (vaddr & 1)) {
+		send_sigsegv(vaddr, T_ADDR_ERR_LD, tf, cause);
+		return;
+	}
+
+	if (copyin((void *)vaddr, &x, 2) != 0) {
+		send_sigsegv(vaddr, T_TLB_LD_MISS, tf, cause);
+		return;
+	}
+
+	tf->tf_regs[(inst>>16)&0x1F] = x;
+
+	update_pc(tf, cause);
+}
+
+void
+mips_emul_lhu(uint32_t inst, struct trapframe *tf, uint32_t cause)
+{
+	intptr_t	vaddr;
+	int16_t		offset;
+	uint16_t	x;
+
+	offset = inst & 0xFFFF;
+	vaddr = tf->tf_regs[(inst>>21)&0x1F] + offset;
+
+	/* segment and alignment check */
+	if (vaddr > VM_MAXUSER_ADDRESS || (vaddr & 1)) {
+		send_sigsegv(vaddr, T_ADDR_ERR_LD, tf, cause);
+		return;
+	}
+
+	if (copyin((void *)vaddr, &x, 2) != 0) {
+		send_sigsegv(vaddr, T_TLB_LD_MISS, tf, cause);
+		return;
+	}
+
 	tf->tf_regs[(inst>>16)&0x1F] = (mips_ureg_t)x;
 
@@ -696,20 +712,20 @@
 
 void
-bcemul_lh(uint32_t inst, struct trapframe *tf, uint32_t cause)
-{
-	intptr_t	vaddr;
-	int16_t		offset;
-	int16_t		x;
-
-	offset = inst & 0xFFFF;
-	vaddr = tf->tf_regs[(inst>>21)&0x1F] + offset;
-
-	/* segment and alignment check */
-	if (vaddr > VM_MAXUSER_ADDRESS || (vaddr & 1)) {
-		send_sigsegv(vaddr, T_ADDR_ERR_LD, tf, cause);
-		return;
-	}
-
-	if (copyin((void *)vaddr, &x, 2) != 0) {
+mips_emul_lw(uint32_t inst, struct trapframe *tf, uint32_t cause)
+{
+	intptr_t	vaddr;
+	int16_t		offset;
+	int32_t		x;
+
+	offset = inst & 0xFFFF;
+	vaddr = tf->tf_regs[(inst>>21)&0x1F] + offset;
+
+	/* segment and alignment check */
+	if (vaddr > VM_MAXUSER_ADDRESS || (vaddr & 3)) {
+		send_sigsegv(vaddr, T_ADDR_ERR_LD, tf, cause);
+		return;
+	}
+
+	if (copyin((void *)vaddr, &x, 4) != 0) {
 		send_sigsegv(vaddr, T_TLB_LD_MISS, tf, cause);
 		return;
@@ -722,54 +738,5 @@
 
 void
-bcemul_lhu(uint32_t inst, struct trapframe *tf, uint32_t cause)
-{
-	intptr_t	vaddr;
-	int16_t		offset;
-	u_int16_t	x;
-
-	offset = inst & 0xFFFF;
-	vaddr = tf->tf_regs[(inst>>21)&0x1F] + offset;
-
-	/* segment and alignment check */
-	if (vaddr > VM_MAXUSER_ADDRESS || (vaddr & 1)) {
-		send_sigsegv(vaddr, T_ADDR_ERR_LD, tf, cause);
-		return;
-	}
-
-	if (copyin((void *)vaddr, &x, 2) != 0) {
-		send_sigsegv(vaddr, T_TLB_LD_MISS, tf, cause);
-		return;
-	}
-
-	tf->tf_regs[(inst>>16)&0x1F] = (mips_ureg_t)x;
-
-	update_pc(tf, cause);
-}
-
-void
-bcemul_lw(uint32_t inst, struct trapframe *tf, uint32_t cause)
-{
-	intptr_t	vaddr;
-	int16_t		offset;
-
-	offset = inst & 0xFFFF;
-	vaddr = tf->tf_regs[(inst>>21)&0x1F] + offset;
-
-	/* segment and alignment check */
-	if (vaddr > VM_MAXUSER_ADDRESS || (vaddr & 3)) {
-		send_sigsegv(vaddr, T_ADDR_ERR_LD, tf, cause);
-		return;
-	}
-
-	if (copyin((void *)vaddr, &(tf->tf_regs[(inst>>16)&0x1F]), 4) != 0) {
-		send_sigsegv(vaddr, T_TLB_LD_MISS, tf, cause);
-		return;
-	}
-
-	update_pc(tf, cause);
-}
-
-void
-bcemul_lwl(uint32_t inst, struct trapframe *tf, uint32_t cause)
+mips_emul_lwl(uint32_t inst, struct trapframe *tf, uint32_t cause)
 {
 	intptr_t	vaddr;
@@ -804,7 +771,7 @@
 
 void
-bcemul_lwr(uint32_t inst, struct trapframe *tf, uint32_t cause)
-{
-	intptr_t		vaddr;
+mips_emul_lwr(uint32_t inst, struct trapframe *tf, uint32_t cause)
+{
+	intptr_t	vaddr;
 	uint32_t	a, x, shift;
 	int16_t		offset;
@@ -838,5 +805,31 @@
 #if defined(__mips_n32) || defined(__mips_n64) || defined(__mips_o64)
 void
-bcemul_ld(uint32_t inst, struct trapframe *tf, uint32_t cause)
+mips_emul_lwu(uint32_t inst, struct trapframe *tf, uint32_t cause)
+{
+	intptr_t	vaddr;
+	int16_t		offset;
+	uint32_t	x;
+
+	offset = inst & 0xFFFF;
+	vaddr = tf->tf_regs[(inst>>21)&0x1F] + offset;
+
+	/* segment and alignment check */
+	if (vaddr > VM_MAX_ADDRESS || vaddr & 0x3) {
+		send_sigsegv(vaddr, T_ADDR_ERR_LD, tf, cause);
+		return;
+	}
+
+	if (copyin((void *)vaddr, &x, 4) != 0) {
+		send_sigsegv(vaddr, T_TLB_LD_MISS, tf, cause);
+		return;
+	}
+
+	tf->tf_regs[(inst>>16)&0x1F] = x;
+
+	update_pc(tf, cause);
+}
+
+void
+mips_emul_ld(uint32_t inst, struct trapframe *tf, uint32_t cause)
 {
 	intptr_t	vaddr;
@@ -861,5 +854,5 @@
 
 void
-bcemul_ldl(uint32_t inst, struct trapframe *tf, uint32_t cause)
+mips_emul_ldl(uint32_t inst, struct trapframe *tf, uint32_t cause)
 {
 	intptr_t	vaddr;
@@ -895,5 +888,5 @@
 
 void
-bcemul_ldr(uint32_t inst, struct trapframe *tf, uint32_t cause)
+mips_emul_ldr(uint32_t inst, struct trapframe *tf, uint32_t cause)
 {
 	intptr_t	vaddr;
@@ -930,5 +923,5 @@
 
 void
-bcemul_sb(uint32_t inst, struct trapframe *tf, uint32_t cause)
+mips_emul_sb(uint32_t inst, struct trapframe *tf, uint32_t cause)
 {
 	intptr_t	vaddr;
@@ -953,5 +946,5 @@
 
 void
-bcemul_sh(uint32_t inst, struct trapframe *tf, uint32_t cause)
+mips_emul_sh(uint32_t inst, struct trapframe *tf, uint32_t cause)
 {
 	intptr_t	vaddr;
@@ -976,5 +969,5 @@
 
 void
-bcemul_sw(uint32_t inst, struct trapframe *tf, uint32_t cause)
+mips_emul_sw(uint32_t inst, struct trapframe *tf, uint32_t cause)
 {
 	intptr_t	vaddr;
@@ -999,5 +992,5 @@
 
 void
-bcemul_swl(uint32_t inst, struct trapframe *tf, uint32_t cause)
+mips_emul_swl(uint32_t inst, struct trapframe *tf, uint32_t cause)
 {
 	intptr_t	vaddr;
@@ -1035,5 +1028,5 @@
 
 void
-bcemul_swr(uint32_t inst, struct trapframe *tf, uint32_t cause)
+mips_emul_swr(uint32_t inst, struct trapframe *tf, uint32_t cause)
 {
 	intptr_t	vaddr;
@@ -1072,5 +1065,5 @@
 #if defined(__mips_n32) || defined(__mips_n64) || defined(__mips_o64)
 void
-bcemul_sd(uint32_t inst, struct trapframe *tf, uint32_t cause)
+mips_emul_sd(uint32_t inst, struct trapframe *tf, uint32_t cause)
 {
 	intptr_t	vaddr;
@@ -1095,5 +1088,5 @@
 
 void
-bcemul_sdl(uint32_t inst, struct trapframe *tf, uint32_t cause)
+mips_emul_sdl(uint32_t inst, struct trapframe *tf, uint32_t cause)
 {
 	intptr_t	vaddr;
@@ -1132,5 +1125,5 @@
 
 void
-bcemul_sdr(uint32_t inst, struct trapframe *tf, uint32_t cause)
+mips_emul_sdr(uint32_t inst, struct trapframe *tf, uint32_t cause)
 {
 	intptr_t	vaddr;
Index: /trunk/src/sys/arch/mips/mips/mips_fixup.c
===================================================================
--- /trunk/src/sys/arch/mips/mips/mips_fixup.c	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/mips_fixup.c	(revision 152)
@@ -29,7 +29,8 @@
 
 #include <sys/cdefs.h>
-
-__KERNEL_RCSID(0, "$NetBSD: mips_fixup.c,v 1.1.2.5 2010/03/01 19:26:01 matt Exp $");
-
+__KERNEL_RCSID(0, "mips_fixup.c,v 1.1.2.10 2011/04/29 08:26:28 matt Exp");
+
+#include "opt_mips3_wired.h"
+#include "opt_multiprocessor.h"
 #include "opt_cputype.h"
 #include <sys/param.h>
@@ -40,10 +41,14 @@
 #include <mips/cache.h>
 #include <mips/mips3_pte.h>
+#include <mips/regnum.h>
 
 #define	INSN_LUI_P(insn)	(((insn) >> 26) == 017)
 #define	INSN_LW_P(insn)		(((insn) >> 26) == 043)
+#define	INSN_SW_P(insn)		(((insn) >> 26) == 053)
 #define	INSN_LD_P(insn)		(((insn) >> 26) == 067)
+#define	INSN_SD_P(insn)		(((insn) >> 26) == 077)
 
 #define INSN_LOAD_P(insn)	(INSN_LD_P(insn) || INSN_LW_P(insn))
+#define INSN_STORE_P(insn)	(INSN_SD_P(insn) || INSN_SW_P(insn))
 
 bool
@@ -64,8 +69,9 @@
 	 * the value.
 	 */
-	const int32_t upper_addr = (addr & ~0xffff) + ((addr << 1) & 0x10000);
+	const int32_t upper_addr = (addr + 32768) & ~0xffff;
 
 	KASSERT((addr & ~0xfff) == ((addr + size - 1) & ~0xfff));
 
+	uint32_t lui_insn = 0;
 	for (uint32_t *insnp = start; insnp < end; insnp++) {
 		const uint32_t insn = *insnp;
@@ -78,6 +84,8 @@
 			    insn, lui_reg, offset);
 #endif
+			KASSERT(lui_reg == _R_K0 || lui_reg == _R_K1);
 			if (upper_addr == offset) {
 				lui_insnp = insnp;
+				lui_insn = insn;
 #ifdef DEBUG_VERBOSE
 				printf(" (maybe)");
@@ -85,31 +93,42 @@
 			} else {
 				lui_insnp = NULL;
+				lui_insn = 0;
 			}
 #ifdef DEBUG_VERBOSE
 			printf("\n");
 #endif
-		} else if (lui_insnp != NULL && INSN_LOAD_P(insn)) {
+		} else if (lui_insn != 0
+			   && (INSN_LOAD_P(insn) || INSN_STORE_P(insn))) {
 			size_t base = (insn >> 21) & 31;
+#if defined(DIAGNOSTIC) || defined(DEBUG_VERBOSE)
 			size_t rt = (insn >> 16) & 31;
+#endif
 			int32_t load_addr = upper_addr + (int16_t)insn;
 			if (addr <= load_addr
 			    && load_addr < addr + size
-			    && base == lui_reg
-			    && rt == lui_reg) {
+			    && base == lui_reg) {
+				KASSERT(rt == _R_K0 || rt == _R_K1);
 #ifdef DEBUG_VERBOSE
 				printf("%s: %#x: insn %08x: %s r%zu, %%lo(%08x)(r%zu)\n",
 				    __func__, (int32_t)(intptr_t)insnp,
-				    insn, INSN_LW_P(insn) ? "lw" : "ld",
+				    insn,
+				    INSN_LOAD_P(insn)
+					? INSN_LW_P(insn) ? "lw" : "ld"
+					: INSN_SW_P(insn) ? "sw" : "sd",
 				    rt, load_addr, base);
 #endif
-				new_insns[0] = *lui_insnp;
+				new_insns[0] = lui_insn;
 				new_insns[1] = *insnp;
 				if ((callback)(load_addr, new_insns)) {
-					*lui_insnp = new_insns[0];
-					*insnp = new_insns[1];
+					if (lui_insnp) {
+						*lui_insnp = new_insns[0];
+						*insnp = new_insns[1];
+					} else if (new_insns[1] == 0) {
+						*insnp = new_insns[0];
+					} else {
+						*insnp = new_insns[1];
+					}
 					fixed = true;
 				}
-				lui_insnp = NULL;
-			} else if (rt == lui_reg) {
 				lui_insnp = NULL;
 			}
@@ -124,4 +143,5 @@
 
 #ifndef TSAR
+#ifdef MIPS3_PLUS
 bool
 mips_fixup_zero_relative(int32_t load_addr, uint32_t new_insns[2])
@@ -149,5 +169,7 @@
 	printf("%s: %08x: insn#1 %08x: %s r%u, %d(r%u)\n",
 	    __func__, (int32_t)load_addr, new_insns[0],
-	    INSN_LW_P(new_insns[0]) ? "lw" : "ld",
+	    INSN_LOAD_P(new_insns[0])
+		? INSN_LW_P(new_insns[0]) ? "lw" : "ld"
+		: INSN_LW_P(new_insns[0]) ? "sw" : "sd",
 	    (new_insns[0] >> 16) & 31,
 	    (int16_t)new_insns[0],
@@ -167,5 +189,6 @@
 	if (ci->ci_tlb_slot < 0) {
 		ci->ci_tlb_slot = ti->ti_wired++;
-		mips3_cp0_wired_write(ti->ti_wired);
+		if (MIPS_HAS_R4K_MMU)
+			mips3_cp0_wired_write(ti->ti_wired);
 		tlb_enter(ci->ci_tlb_slot, -PAGE_SIZE, tlb_lo);
 	}
@@ -174,4 +197,5 @@
 	return true;
 }
+#endif /* MIPS3_PLUS */
 #endif /* !TSAR */
 
@@ -206,24 +230,25 @@
 
 void
-mips_fixup_stubs(uint32_t *start, uint32_t *end,
-	const struct mips_jump_fixup_info *fixups,
-	size_t nfixups)
-{
-	const uint32_t min_offset = fixups[0].jfi_stub;
-	const uint32_t max_offset = fixups[nfixups-1].jfi_stub;
+mips_fixup_stubs(uint32_t *start, uint32_t *end)
+{
 #ifdef DEBUG
 	size_t fixups_done = 0;
-	uint32_t cycles = (CPUISMIPS3 ? mips3_cp0_count_read() : 0);
-#endif
-
-#ifdef DIAGNOGSTIC
-	/*
-	 * Verify the fixup list is sorted from low stub to high stub.
-	 */
-	for (const struct mips_jump_fixup_info *jfi = fixups + 1;
-	     jfi < fixups + nfixups; jfi++) {
-		KASSERT(jfi[-1].jfi_stub < jfi[0].jfi_stub);
-	}
-#endif
+	uint32_t cycles =
+#if (MIPS3 + MIPS4 + MIPS32 + MIPS32R2 + MIPS64 + MIPS64R2 + MIPS64_RMIXL + MIPS64R2_RMIXL) > 0
+	    (CPUISMIPS3 ? mips3_cp0_count_read() : 0);
+#else
+	    0;
+#endif
+#endif
+	extern uint32_t __stub_start[], __stub_end[];
+
+#ifndef TSAR
+	KASSERT(MIPS_KSEG0_P(start));
+	KASSERT(MIPS_KSEG0_P(end));
+	KASSERT(MIPS_KSEG0_START == (((intptr_t)start >> 28) << 28));
+#endif
+
+	if (end > __stub_start)
+		end = __stub_start;
 
 	for (uint32_t *insnp = start; insnp < end; insnp++) {
@@ -231,4 +256,6 @@
 		uint32_t offset = insn & 0x03ffffff;
 		uint32_t opcode = insn >> 26;
+		const uint32_t * const stubp =
+		    &((uint32_t *)(((intptr_t)insnp >> 28) << 28))[offset];
 
 		/*
@@ -237,34 +264,69 @@
 		 */
 		if ((opcode != OPCODE_J && opcode != OPCODE_JAL)
-		    || offset < min_offset || max_offset < offset)
+		    || stubp < __stub_start || __stub_end <= stubp)
 			continue;
 
 		/*
-		 * We know it's a jump, but does it match one we want to
-		 * fixup?
+		 * Stubs typically look like:
+		 *	lui	v0, %hi(sym)
+		 *	lX	t9, %lo(sym)(v0)
+		 *	[nop]
+		 *	jr	t9
+		 *	nop
 		 */
-		for (const struct mips_jump_fixup_info *jfi = fixups;
-		     jfi < fixups + nfixups; jfi++) {
-			/*
-			 * The caller has sorted the fixup list from lowest
-			 * stub to highest stub so if the current offset is
-			 * less than the this fixup's stub offset, we know
-			 * can't match anything else in the fixup list.
-			 */
-			if (jfi->jfi_stub > offset)
-				break;
-
-			if (jfi->jfi_stub == offset) {
-				/*
-				 * Yes, we need to fix it up.  Replace the old
-				 * displacement with the real displacement.
-				 */
-				fixup_mips_jump(insnp, jfi);
+		const uint32_t lui_insn = stubp[0];
+		const uint32_t load_insn = stubp[1];
+#ifdef DIAGNOSTIC
+		if (stubp[2] == 0) {
+			KASSERT(stubp[3] == 0x03200008);	/* jr t9 */
+			KASSERT(stubp[4] == 0);			/* nop */
+		} else {
+			KASSERT(stubp[2] == 0x03200008);	/* jr t9 */
+			KASSERT(stubp[3] == 0);			/* nop */
+		}
+
+		KASSERT(INSN_LUI_P(lui_insn));
+#ifdef _LP64
+		KASSERT(INSN_LD_P(load_insn));
+#else
+		KASSERT(INSN_LW_P(load_insn));
+#endif
+		const u_int lui_reg = (lui_insn >> 16) & 31;
+		const u_int load_reg = (load_insn >> 16) & 31;
+#endif
+		KASSERT(((load_insn >> 21) & 31) == lui_reg);
+		KASSERT(load_reg == _R_T9);
+
+		intptr_t load_addr = ((int16_t)lui_insn << 16) + (int16_t) load_insn;
+#ifdef _LP64
+		const intptr_t real_addr = *(int64_t *)load_addr;
+#else
+		const intptr_t real_addr = *(int32_t *)load_addr;
+#endif
+		/*
+		 * If the real_addr has been set yet, don't fix up.
+		 */
+		if (real_addr == 0) {
+			continue;
+		}
+		/*
+		 * Verify the real destination is in the same 256MB
+		 * as the location of the jump instruction.
+		 */
+		KASSERT((real_addr >> 28) == ((intptr_t)insnp >> 28));
+
+		/*
+		 * Now fix it up.  Replace the old displacement to the stub
+		 * with the real displacement.
+		 */
+		struct mips_jump_fixup_info fixup = {
+		    .jfi_stub = fixup_addr2offset(stubp),
+		    .jfi_real = fixup_addr2offset(real_addr),
+		};
+
+		fixup_mips_jump(insnp, &fixup);
 #ifdef DEBUG
-				fixups_done++;
-#endif
-				break;
-			}
-		}
+		fixups_done++;
+#endif
 	}
 
@@ -278,6 +340,8 @@
 
 #ifdef DEBUG
+#if (MIPS3 + MIPS4 + MIPS32 + MIPS32R2 + MIPS64 + MIPS64R2 + MIPS64_RMIXL + MIPS64R2_RMIXL) > 0
 	if (CPUISMIPS3)
 		cycles = mips3_cp0_count_read() - cycles;
+#endif
 	printf("%s: %zu fixup%s done in %u cycles\n", __func__,
 	    fixups_done, fixups_done == 1 ? "" : "s",
@@ -286,22 +350,188 @@
 }
 
-void mips_cpu_switch_resume(struct lwp *l) __section(".stub");
+#define	__stub		__section(".stub")
+
+void	mips_cpu_switch_resume(struct lwp *)		__stub;
+void	tlb_set_asid(uint32_t)				__stub;
+void	tlb_invalidate_all(void)			__stub;
+void	tlb_invalidate_globals(void)			__stub;
+void	tlb_invalidate_asids(uint32_t, uint32_t)	__stub;
+void	tlb_invalidate_addr(vaddr_t)			__stub;
+u_int	tlb_record_asids(u_long *, uint32_t)		__stub;
+int	tlb_update(vaddr_t, uint32_t)			__stub;
+void	tlb_enter(size_t, vaddr_t, uint32_t)		__stub;
+void	tlb_read_indexed(size_t, struct tlbmask *)	__stub;
+void	tlb_write_indexed(size_t, const struct tlbmask *) __stub;
+
+/*
+ * wbflush isn't a stub since it gets overridden quite late
+ * (after mips_vector_init returns).
+ */
+void	wbflush(void)					/*__stub*/;
 
 void
 mips_cpu_switch_resume(struct lwp *l)
 {
-	(*mips_locoresw.lsw_cpu_switch_resume)(l);
-}
-
-void
-fixup_mips_cpu_switch_resume(void)
-{
-	extern uint32_t __cpu_switchto_fixup[];
-
-	struct mips_jump_fixup_info fixup = {
-		fixup_addr2offset(mips_cpu_switch_resume),
-		fixup_addr2offset(mips_locoresw.lsw_cpu_switch_resume)
-	};
-
-	fixup_mips_jump(__cpu_switchto_fixup, &fixup);
-}
+	(*mips_locore_jumpvec.ljv_cpu_switch_resume)(l);
+}
+
+#ifndef TSAR
+void
+tlb_set_asid(uint32_t asid)
+{
+        (*mips_locore_jumpvec.ljv_tlb_set_asid)(asid);  
+}
+
+void
+tlb_invalidate_all(void)
+{
+        (*mips_locore_jumpvec.ljv_tlb_invalidate_all)();
+}
+
+void
+tlb_invalidate_addr(vaddr_t va)
+{
+        (*mips_locore_jumpvec.ljv_tlb_invalidate_addr)(va);
+}
+
+void
+tlb_invalidate_globals(void)
+{
+        (*mips_locore_jumpvec.ljv_tlb_invalidate_globals)();
+}
+
+void
+tlb_invalidate_asids(uint32_t asid_lo, uint32_t asid_hi)
+{
+        (*mips_locore_jumpvec.ljv_tlb_invalidate_asids)(asid_lo, asid_hi);
+}
+
+u_int
+tlb_record_asids(u_long *bitmap, uint32_t asid_max)
+{
+        return (*mips_locore_jumpvec.ljv_tlb_record_asids)(bitmap, asid_max);
+}
+
+int
+tlb_update(vaddr_t va, uint32_t pte)
+{
+        return (*mips_locore_jumpvec.ljv_tlb_update)(va, pte);
+}
+
+void
+tlb_enter(size_t tlbno, vaddr_t va, uint32_t pte)
+{
+        (*mips_locore_jumpvec.ljv_tlb_enter)(tlbno, va, pte);
+}
+
+void
+tlb_read_indexed(size_t tlbno, struct tlbmask *tlb)
+{
+        (*mips_locore_jumpvec.ljv_tlb_read_indexed)(tlbno, tlb);
+}
+
+void
+tlb_write_indexed(size_t tlbno, const struct tlbmask *tlb)
+{
+        (*mips_locore_jumpvec.ljv_tlb_write_indexed)(tlbno, tlb);
+}
+#endif /* !TSAR */
+
+void
+wbflush(void)
+{
+        (*mips_locoresw.lsw_wbflush)();
+}
+
+#ifndef LOCKDEBUG
+void mutex_enter(kmutex_t *mtx)				__stub;
+void mutex_exit(kmutex_t *mtx)				__stub;
+void mutex_spin_enter(kmutex_t *mtx)			__stub;
+void mutex_spin_exit(kmutex_t *mtx)			__stub;
+
+void
+mutex_enter(kmutex_t *mtx)
+{
+
+	(*mips_locore_atomicvec.lav_mutex_enter)(mtx);
+}
+
+void
+mutex_exit(kmutex_t *mtx)
+{
+
+	(*mips_locore_atomicvec.lav_mutex_exit)(mtx);
+}
+
+void
+mutex_spin_enter(kmutex_t *mtx)
+{
+
+	(*mips_locore_atomicvec.lav_mutex_spin_enter)(mtx);
+}
+
+void
+mutex_spin_exit(kmutex_t *mtx)
+{
+
+	(*mips_locore_atomicvec.lav_mutex_spin_exit)(mtx);
+}
+#endif	/* !LOCKDEBUG */
+
+u_int _atomic_cas_uint(volatile u_int *, u_int, u_int)		__stub;
+u_long _atomic_cas_ulong(volatile u_long *, u_long, u_long)	__stub;
+
+u_int
+_atomic_cas_uint(volatile u_int *ptr, u_int old, u_int new)
+{
+
+	return (*mips_locore_atomicvec.lav_atomic_cas_uint)(ptr, old, new);
+}
+
+u_long
+_atomic_cas_ulong(volatile u_long *ptr, u_long old, u_long new)
+{
+
+	return (*mips_locore_atomicvec.lav_atomic_cas_ulong)(ptr, old, new);
+}
+
+__strong_alias(atomic_cas_uint, _atomic_cas_uint)
+__strong_alias(atomic_cas_uint_ni, _atomic_cas_uint)
+__strong_alias(_atomic_cas_32, _atomic_cas_uint)
+__strong_alias(_atomic_cas_32_ni, _atomic_cas_uint)
+__strong_alias(atomic_cas_32, _atomic_cas_uint)
+__strong_alias(atomic_cas_32_ni, _atomic_cas_uint)
+__strong_alias(atomic_cas_ptr, _atomic_cas_ulong)
+__strong_alias(atomic_cas_ptr_ni, _atomic_cas_ulong)
+__strong_alias(atomic_cas_ulong, _atomic_cas_ulong)
+__strong_alias(atomic_cas_ulong_ni, _atomic_cas_ulong)
+#ifdef _LP64
+__strong_alias(atomic_cas_64, _atomic_cas_ulong)
+__strong_alias(atomic_cas_64_ni, _atomic_cas_ulong)
+__strong_alias(_atomic_cas_64, _atomic_cas_ulong)
+__strong_alias(_atomic_cas_64_ni, _atomic_cas_ulong)
+#endif
+
+int	ucas_uint(volatile u_int *, u_int, u_int, u_int *)	__stub;
+int	ucas_ulong(volatile u_long *, u_long, u_long, u_long *)	__stub;
+
+int
+ucas_uint(volatile u_int *ptr, u_int old, u_int new, u_int *retp)
+{
+
+	return (*mips_locore_atomicvec.lav_ucas_uint)(ptr, old, new, retp);
+}
+__strong_alias(ucas_32, ucas_uint);
+__strong_alias(ucas_int, ucas_uint);
+
+int
+ucas_ulong(volatile u_long *ptr, u_long old, u_long new, u_long *retp)
+{
+
+	return (*mips_locore_atomicvec.lav_ucas_ulong)(ptr, old, new, retp);
+}
+__strong_alias(ucas_ptr, ucas_ulong);
+__strong_alias(ucas_long, ucas_ulong);
+#ifdef _LP64
+__strong_alias(ucas_64, ucas_ulong);
+#endif
